

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to set up ‘live’ logging with pywws &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="User guides" href="index.html" />
    <link rel="next" title="How to configure pywws to post messages to Twitter" href="twitter.html" />
    <link rel="prev" title="How to set up ‘hourly’ logging with pywws" href="hourlylogging.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="twitter.html" title="How to configure pywws to post messages to Twitter"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="hourlylogging.html" title="How to set up ‘hourly’ logging with pywws"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">User guides</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="how-to-set-up-live-logging-with-pywws">
<h1>How to set up &#8216;live&#8217; logging with pywws<a class="headerlink" href="#how-to-set-up-live-logging-with-pywws" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>There are two quite different modes of operation with pywws. Traditionally the <a class="reference internal" href="../api/Hourly.html"><em>Hourly</em></a> program would be run at regular intervals (usually an hour) from cron. This is suitable for fairly static websites, but more frequent updates can be useful for sites such as Weather Underground (<a class="reference external" href="http://www.wunderground.com/">http://www.wunderground.com/</a>). The newer <a class="reference internal" href="../api/LiveLog.html"><em>LiveLog</em></a> program runs continuously and can upload data every 48 seconds.</p>
</div>
<div class="section" id="getting-started">
<h2>Getting started<a class="headerlink" href="#getting-started" title="Permalink to this headline">¶</a></h2>
<p>First of all, you need to install pywws and make sure it can get data from your weather station. See <a class="reference internal" href="getstarted.html"><em>How to get started with pywws</em></a> for details.</p>
<p>Try running LiveLog.py from the command line, with a high level of verbosity so you can see what&#8217;s happening:</p>
<div class="highlight-python"><pre>python LiveLog.py -vvv ~/weather/data</pre>
</div>
<p>Within five minutes (assuming you have set a 5 minute logging interval) you should see a &#8216;live_data new ptr&#8217; message, followed by fetching any new data from the weather station and processing it. Let LiveLog.py run for a minute or two longer, then kill the process by typing &#8216;&lt;Ctrl&gt;C&#8217;.</p>
</div>
<div class="section" id="configuring-file-locations">
<h2>Configuring file locations<a class="headerlink" href="#configuring-file-locations" title="Permalink to this headline">¶</a></h2>
<p>Open your weather.ini file with a text editor. You should have a <tt class="docutils literal"><span class="pre">[paths]</span></tt> section similar to the following (where <tt class="docutils literal"><span class="pre">xxx</span></tt> is your user name):</p>
<div class="highlight-python"><pre>[paths]
work = /tmp/weather
templates = /home/xxx/weather/templates/
graph_templates = /home/xxx/weather/graph_templates/</pre>
</div>
<p>Edit these to suit your installation and preferences. <tt class="docutils literal"><span class="pre">work</span></tt> is a temporary directory used to store intermediate files, <tt class="docutils literal"><span class="pre">templates</span></tt> is the directory where you keep your text template files and <tt class="docutils literal"><span class="pre">graph_templates</span></tt> is the directory where you keep your graph template files. Don&#8217;t use the pywws example directories for these, as they will get over-written when you upgrade pywws.</p>
<p>Copy your text and graph templates to the appropriate directories. You may find some of the examples provided with pywws useful to get started.</p>
</div>
<div class="section" id="configuring-periodic-tasks">
<h2>Configuring periodic tasks<a class="headerlink" href="#configuring-periodic-tasks" title="Permalink to this headline">¶</a></h2>
<p>In weather.ini you should have a <tt class="docutils literal"><span class="pre">[live]</span></tt> section similar to the following:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="p">[</span><span class="n">live</span><span class="p">]</span>
<span class="n">services</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">twitter</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">plot</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">text</span> <span class="o">=</span> <span class="p">[]</span>
</pre></div>
</div>
<p>This section specifies what pywws should do every time it gets a new reading from the weather station, i.e. every 48 seconds. The <tt class="docutils literal"><span class="pre">services</span></tt> entry is a list of online weather services to upload data to, e.g. <tt class="docutils literal"><span class="pre">['underground']</span></tt>. The <tt class="docutils literal"><span class="pre">plot</span></tt> and <tt class="docutils literal"><span class="pre">text</span></tt> entries are lists of template files for plots and text files to be uploaded to your web site, and the <tt class="docutils literal"><span class="pre">twitter</span></tt> entry is a list of templates for messages to be posted to Twitter. You should probably leave all of these blank except for <tt class="docutils literal"><span class="pre">services</span></tt>.</p>
<p>If you use YoWindow (<a class="reference external" href="http://yowindow.com/">http://yowindow.com/</a>) you can add an entry to the <tt class="docutils literal"><span class="pre">[live]</span></tt> section to specify your YoWindow file, e.g.:</p>
<div class="highlight-python"><pre>[live]
yowindow = /home/jim/data/yowindow.xml
services = ['underground']
...</pre>
</div>
<p>If you don&#8217;t already have them, create four more sections in your weather.ini file: <tt class="docutils literal"><span class="pre">[logged]</span></tt>, <tt class="docutils literal"><span class="pre">[hourly]</span></tt>, <tt class="docutils literal"><span class="pre">[12</span> <span class="pre">hourly]</span></tt> and <tt class="docutils literal"><span class="pre">[daily]</span></tt>. These sections should have similar entries to the <tt class="docutils literal"><span class="pre">[live]</span></tt> section, and specify what to do every time data is logged (5 to 30 minutes, depending on your logging interval), every hour, twice daily and once per day. Add the names of your template files to the appropriate entries, for example:</p>
<div class="highlight-python"><pre>[logged]
services = ['underground', 'metoffice']
twitter = []
plot = []
text = []

[hourly]
services = []
twitter = ['tweet.txt']
plot = ['7days.png.xml', '24hrs.png.xml', 'rose_24hrs.png.xml']
text = ['24hrs.txt', '6hrs.txt', '7days.txt']

[12 hourly]
services = []
twitter = []
plot = []
text = []

[daily]
services = []
twitter = ['forecast.txt']
plot = ['28days.png.xml']
text = ['allmonths.txt']</pre>
</div>
</div>
<div class="section" id="run-in-the-background">
<h2>Run in the background<a class="headerlink" href="#run-in-the-background" title="Permalink to this headline">¶</a></h2>
<p>In order to have LiveLog.py carry on running after you finish using your computer it needs to be run as a &#8216;background job&#8217;. On most Linux / UNIX systems you can do this by putting an ampersand (&#8216;&amp;&#8217;) at the end of the command line. For example:</p>
<div class="highlight-python"><pre>python LiveLog.py ~/weather/data &amp;</pre>
</div>
<p>However, it would be useful to know what went wrong if the program crashes for any reason. LiveLog.py can store its messages in a log file, specified with the -l option:</p>
<div class="highlight-python"><pre>python LiveLog.py -v -l ~/weather/data/pywws.log ~/weather/data &amp;</pre>
</div>
</div>
<div class="section" id="automatic-restarting">
<h2>Automatic restarting<a class="headerlink" href="#automatic-restarting" title="Permalink to this headline">¶</a></h2>
<p>There are various ways of configuring a Linux system to start a program when the machine boots up. Typically these involve putting a file in /etc/init.d/, which requires root privileges. A slightly harder problem is ensuring a program restarts if it crashes. My solution to both problems is to run the following script from cron, every hour.</p>
<div class="highlight-python"><pre>#!/bin/sh

pidfile=/var/run/pywws.pid
datadir=/data/weather
logfile=$datadir/live_logger.log

# exit if process is running
[ -f $pidfile ] &amp;&amp; kill -0 `cat $pidfile` &amp;&amp; exit

# email last few lines of the logfile to see why it died
if [ -f $logfile ]; then
  log=/var/log/log-weather
  tail -40 $logfile &gt;$log
  /home/jim/scripts/email-log.sh $log "weather log"
  rm $log
  fi

# restart process
python /home/jim/weather/devel/LiveLog.py -v -l $logfile $datadir &amp;
echo $! &gt;$pidfile</pre>
</div>
<p>This stores the process id of the running LiveLog.py in pidfile. If the process is running, the script does nothing. If the process has crashed, it emails the last 40 lines of the log file to me (using a script that creates a message and passes it to sendmail) and then restarts LiveLog.py. You&#8217;ll need to edit this quite a lot to suit your file locations and so on, but it gives some idea of what to do.</p>
<p>Comments or questions? Please subscribe to the pywws mailing list <a class="reference external" href="http://groups.google.com/group/pywws">http://groups.google.com/group/pywws</a> and let us know.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">How to set up &#8216;live&#8217; logging with pywws</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#getting-started">Getting started</a></li>
<li><a class="reference internal" href="#configuring-file-locations">Configuring file locations</a></li>
<li><a class="reference internal" href="#configuring-periodic-tasks">Configuring periodic tasks</a></li>
<li><a class="reference internal" href="#run-in-the-background">Run in the background</a></li>
<li><a class="reference internal" href="#automatic-restarting">Automatic restarting</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="hourlylogging.html"
                        title="previous chapter">How to set up &#8216;hourly&#8217; logging with pywws</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="twitter.html"
                        title="next chapter">How to configure pywws to post messages to Twitter</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="twitter.html" title="How to configure pywws to post messages to Twitter"
             >next</a> |</li>
        <li class="right" >
          <a href="hourlylogging.html" title="How to set up ‘hourly’ logging with pywws"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >User guides</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>